<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for FareCodePriceIndicator EnumType
 * Meta information extracted from the WSDL
 * - documentation: FareComponent Indicator to determine how the itinerary was priced.0 - System Computer priced (without any manual modification except for the baggage allowance)1 - Manually priced2-9 - For individual airline/system provider useA-Z -
 * Undefined industry useA-Z values are:A: Auto-priced tickets based on continuous pricing methodB: Auto-priced tickets based on classic pricing methodC: Manual tickets based on continuous pricing method relevant for auditD: Manual tickets based on
 * classic pricing method relevant for auditE: Manual priced tickets based on continuous pricing method non-relevant for auditF: Manual priced tickets based on classic pricing method non-relevant for audit
 * @subpackage Enumerations
 */
class FareCodePriceIndicator extends AbstractStructEnumBase
{
    /**
     * Constant for value 'A'
     * @return string 'A'
     */
    const VALUE_A = 'A';
    /**
     * Constant for value 'B'
     * @return string 'B'
     */
    const VALUE_B = 'B';
    /**
     * Constant for value 'C'
     * @return string 'C'
     */
    const VALUE_C = 'C';
    /**
     * Constant for value 'D'
     * @return string 'D'
     */
    const VALUE_D = 'D';
    /**
     * Constant for value '0'
     * @return string '0'
     */
    const VALUE_0 = '0';
    /**
     * Constant for value '1'
     * @return string '1'
     */
    const VALUE_1 = '1';
    /**
     * Constant for value '2'
     * @return string '2'
     */
    const VALUE_2 = '2';
    /**
     * Constant for value '3'
     * @return string '3'
     */
    const VALUE_3 = '3';
    /**
     * Constant for value '4'
     * @return string '4'
     */
    const VALUE_4 = '4';
    /**
     * Constant for value '5'
     * @return string '5'
     */
    const VALUE_5 = '5';
    /**
     * Constant for value '6'
     * @return string '6'
     */
    const VALUE_6 = '6';
    /**
     * Constant for value '7'
     * @return string '7'
     */
    const VALUE_7 = '7';
    /**
     * Constant for value '8'
     * @return string '8'
     */
    const VALUE_8 = '8';
    /**
     * Constant for value '9'
     * @return string '9'
     */
    const VALUE_9 = '9';
    /**
     * Constant for value 'E'
     * @return string 'E'
     */
    const VALUE_E = 'E';
    /**
     * Constant for value 'F'
     * @return string 'F'
     */
    const VALUE_F = 'F';
    /**
     * Constant for value 'G'
     * @return string 'G'
     */
    const VALUE_G = 'G';
    /**
     * Constant for value 'H'
     * @return string 'H'
     */
    const VALUE_H = 'H';
    /**
     * Constant for value 'I'
     * @return string 'I'
     */
    const VALUE_I = 'I';
    /**
     * Constant for value 'J'
     * @return string 'J'
     */
    const VALUE_J = 'J';
    /**
     * Constant for value 'K'
     * @return string 'K'
     */
    const VALUE_K = 'K';
    /**
     * Constant for value 'L'
     * @return string 'L'
     */
    const VALUE_L = 'L';
    /**
     * Constant for value 'M'
     * @return string 'M'
     */
    const VALUE_M = 'M';
    /**
     * Constant for value 'N'
     * @return string 'N'
     */
    const VALUE_N = 'N';
    /**
     * Constant for value 'O'
     * @return string 'O'
     */
    const VALUE_O = 'O';
    /**
     * Constant for value 'P'
     * @return string 'P'
     */
    const VALUE_P = 'P';
    /**
     * Constant for value 'Q'
     * @return string 'Q'
     */
    const VALUE_Q = 'Q';
    /**
     * Constant for value 'R'
     * @return string 'R'
     */
    const VALUE_R = 'R';
    /**
     * Constant for value 'S'
     * @return string 'S'
     */
    const VALUE_S = 'S';
    /**
     * Constant for value 'T'
     * @return string 'T'
     */
    const VALUE_T = 'T';
    /**
     * Constant for value 'U'
     * @return string 'U'
     */
    const VALUE_U = 'U';
    /**
     * Constant for value 'V'
     * @return string 'V'
     */
    const VALUE_V = 'V';
    /**
     * Constant for value 'W'
     * @return string 'W'
     */
    const VALUE_W = 'W';
    /**
     * Constant for value 'X'
     * @return string 'X'
     */
    const VALUE_X = 'X';
    /**
     * Constant for value 'Y'
     * @return string 'Y'
     */
    const VALUE_Y = 'Y';
    /**
     * Constant for value 'Z'
     * @return string 'Z'
     */
    const VALUE_Z = 'Z';
    /**
     * Return allowed values
     * @uses self::VALUE_A
     * @uses self::VALUE_B
     * @uses self::VALUE_C
     * @uses self::VALUE_D
     * @uses self::VALUE_0
     * @uses self::VALUE_1
     * @uses self::VALUE_2
     * @uses self::VALUE_3
     * @uses self::VALUE_4
     * @uses self::VALUE_5
     * @uses self::VALUE_6
     * @uses self::VALUE_7
     * @uses self::VALUE_8
     * @uses self::VALUE_9
     * @uses self::VALUE_E
     * @uses self::VALUE_F
     * @uses self::VALUE_G
     * @uses self::VALUE_H
     * @uses self::VALUE_I
     * @uses self::VALUE_J
     * @uses self::VALUE_K
     * @uses self::VALUE_L
     * @uses self::VALUE_M
     * @uses self::VALUE_N
     * @uses self::VALUE_O
     * @uses self::VALUE_P
     * @uses self::VALUE_Q
     * @uses self::VALUE_R
     * @uses self::VALUE_S
     * @uses self::VALUE_T
     * @uses self::VALUE_U
     * @uses self::VALUE_V
     * @uses self::VALUE_W
     * @uses self::VALUE_X
     * @uses self::VALUE_Y
     * @uses self::VALUE_Z
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_A,
            self::VALUE_B,
            self::VALUE_C,
            self::VALUE_D,
            self::VALUE_0,
            self::VALUE_1,
            self::VALUE_2,
            self::VALUE_3,
            self::VALUE_4,
            self::VALUE_5,
            self::VALUE_6,
            self::VALUE_7,
            self::VALUE_8,
            self::VALUE_9,
            self::VALUE_E,
            self::VALUE_F,
            self::VALUE_G,
            self::VALUE_H,
            self::VALUE_I,
            self::VALUE_J,
            self::VALUE_K,
            self::VALUE_L,
            self::VALUE_M,
            self::VALUE_N,
            self::VALUE_O,
            self::VALUE_P,
            self::VALUE_Q,
            self::VALUE_R,
            self::VALUE_S,
            self::VALUE_T,
            self::VALUE_U,
            self::VALUE_V,
            self::VALUE_W,
            self::VALUE_X,
            self::VALUE_Y,
            self::VALUE_Z,
        );
    }
}
