<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for GenderCodeContentType EnumType
 * Meta information extracted from the WSDL
 * - documentation: Enumeration set for Gender Code. {codeListAgencyName}ICAO{/codeListAgencyName} {codeListName}Document 9303 Sex of the holder{/codeListName}
 * @subpackage Enumerations
 */
class GenderCodeContentType extends AbstractStructEnumBase
{
    /**
     * Constant for value 'F'
     * Meta information extracted from the WSDL
     * - documentation: Female
     * @return string 'F'
     */
    const VALUE_F = 'F';
    /**
     * Constant for value 'M'
     * Meta information extracted from the WSDL
     * - documentation: Male
     * @return string 'M'
     */
    const VALUE_M = 'M';
    /**
     * Constant for value 'U'
     * Meta information extracted from the WSDL
     * - documentation: Unknown
     * @return string 'U'
     */
    const VALUE_U = 'U';
    /**
     * Constant for value 'X'
     * Meta information extracted from the WSDL
     * - documentation: Unspecified
     * @return string 'X'
     */
    const VALUE_X = 'X';
    /**
     * Return allowed values
     * @uses self::VALUE_F
     * @uses self::VALUE_M
     * @uses self::VALUE_U
     * @uses self::VALUE_X
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_F,
            self::VALUE_M,
            self::VALUE_U,
            self::VALUE_X,
        );
    }
}
