<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for POS_TypeCodeContentType EnumType
 * Meta information extracted from the WSDL
 * - documentation: Enumeration values of Point of Sale Code. {codeListAgencyName}IATA{/codeListAgencyName} {codeListIdentifier}PADIS 9800{/codeListIdentifier}
 * @subpackage Enumerations
 */
class POS_TypeCodeContentType extends AbstractStructEnumBase
{
    /**
     * Constant for value 'A'
     * Meta information extracted from the WSDL
     * - documentation: Airline Specific Codes
     * @return string 'A'
     */
    const VALUE_A = 'A';
    /**
     * Constant for value 'H'
     * Meta information extracted from the WSDL
     * - documentation: Home IATA Agency No.
     * @return string 'H'
     */
    const VALUE_H = 'H';
    /**
     * Constant for value 'I'
     * Meta information extracted from the WSDL
     * - documentation: IATA Travel Agency No.
     * @return string 'I'
     */
    const VALUE_I = 'I';
    /**
     * Constant for value 'L'
     * Meta information extracted from the WSDL
     * - documentation: LNIATA Number (CRT Address)
     * @return string 'L'
     */
    const VALUE_L = 'L';
    /**
     * Constant for value 'T'
     * Meta information extracted from the WSDL
     * - documentation: Pseudo Code/Travel Agency Code
     * @return string 'T'
     */
    const VALUE_T = 'T';
    /**
     * Constant for value 'U'
     * Meta information extracted from the WSDL
     * - documentation: Home Travel Agency Code
     * @return string 'U'
     */
    const VALUE_U = 'U';
    /**
     * Constant for value 'V'
     * Meta information extracted from the WSDL
     * - documentation: CRS/CXR Department Code
     * @return string 'V'
     */
    const VALUE_V = 'V';
    /**
     * Constant for value 'X'
     * Meta information extracted from the WSDL
     * - documentation: Department/Identifier
     * @return string 'X'
     */
    const VALUE_X = 'X';
    /**
     * Return allowed values
     * @uses self::VALUE_A
     * @uses self::VALUE_H
     * @uses self::VALUE_I
     * @uses self::VALUE_L
     * @uses self::VALUE_T
     * @uses self::VALUE_U
     * @uses self::VALUE_V
     * @uses self::VALUE_X
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_A,
            self::VALUE_H,
            self::VALUE_I,
            self::VALUE_L,
            self::VALUE_T,
            self::VALUE_U,
            self::VALUE_V,
            self::VALUE_X,
        );
    }
}
