<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for PayerAuthenticationExemptionCodeContentType EnumType
 * Meta information extracted from the WSDL
 * - documentation: Lists type of Payer Authentication Exemptions
 * @subpackage Enumerations
 */
class PayerAuthenticationExemptionCodeContentType extends AbstractStructEnumBase
{
    /**
     * Constant for value 'AO'
     * Meta information extracted from the WSDL
     * - documentation: Authentication Outage
     * @return string 'AO'
     */
    const VALUE_AO = 'AO';
    /**
     * Constant for value 'DA'
     * Meta information extracted from the WSDL
     * - documentation: Delegated authentication
     * @return string 'DA'
     */
    const VALUE_DA = 'DA';
    /**
     * Constant for value 'LV'
     * Meta information extracted from the WSDL
     * - documentation: Low Value Exemption
     * @return string 'LV'
     */
    const VALUE_LV = 'LV';
    /**
     * Constant for value 'MA'
     * Meta information extracted from the WSDL
     * - documentation: Merchant Problem and Major Outage
     * @return string 'MA'
     */
    const VALUE_MA = 'MA';
    /**
     * Constant for value 'ND'
     * Meta information extracted from the WSDL
     * - documentation: None defined
     * @return string 'ND'
     */
    const VALUE_ND = 'ND';
    /**
     * Constant for value 'SC'
     * Meta information extracted from the WSDL
     * - documentation: Secure Corporate Exemption
     * @return string 'SC'
     */
    const VALUE_SC = 'SC';
    /**
     * Constant for value 'TB'
     * Meta information extracted from the WSDL
     * - documentation: Trusted Beneficiary Exemption
     * @return string 'TB'
     */
    const VALUE_TB = 'TB';
    /**
     * Constant for value 'TR'
     * Meta information extracted from the WSDL
     * - documentation: Transaction Risk Analysis Exemption
     * @return string 'TR'
     */
    const VALUE_TR = 'TR';
    /**
     * Return allowed values
     * @uses self::VALUE_AO
     * @uses self::VALUE_DA
     * @uses self::VALUE_LV
     * @uses self::VALUE_MA
     * @uses self::VALUE_ND
     * @uses self::VALUE_SC
     * @uses self::VALUE_TB
     * @uses self::VALUE_TR
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_AO,
            self::VALUE_DA,
            self::VALUE_LV,
            self::VALUE_MA,
            self::VALUE_ND,
            self::VALUE_SC,
            self::VALUE_TB,
            self::VALUE_TR,
        );
    }
}
