<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for PrefLevelCode EnumType
 * Meta information extracted from the WSDL
 * - documentation: Level of preference requested. Examples: Preferred, Required or Exclude.
 * @subpackage Enumerations
 */
class PrefLevelCode extends AbstractStructEnumBase
{
    /**
     * Constant for value 'Exclude'
     * Meta information extracted from the WSDL
     * - documentation: Exclude | Exclude
     * @return string 'Exclude'
     */
    const VALUE_EXCLUDE = 'Exclude';
    /**
     * Constant for value 'Preferred'
     * Meta information extracted from the WSDL
     * - documentation: Preferred | Preferred
     * @return string 'Preferred'
     */
    const VALUE_PREFERRED = 'Preferred';
    /**
     * Constant for value 'Required'
     * Meta information extracted from the WSDL
     * - documentation: Required | Required
     * @return string 'Required'
     */
    const VALUE_REQUIRED = 'Required';
    /**
     * Return allowed values
     * @uses self::VALUE_EXCLUDE
     * @uses self::VALUE_PREFERRED
     * @uses self::VALUE_REQUIRED
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_EXCLUDE,
            self::VALUE_PREFERRED,
            self::VALUE_REQUIRED,
        );
    }
}
