<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for TravelAgencyTypeCodeContentType EnumType
 * Meta information extracted from the WSDL
 * - documentation: Agency/ Agent Identification Type. {codeListAgencyName}PADIS{/codeListAgencyName} {codeListName}Identification type{/codeListName} {codeListIdentifier}9893{/codeListIdentifier}
 * @subpackage Enumerations
 */
class TravelAgencyTypeCodeContentType extends AbstractStructEnumBase
{
    /**
     * Constant for value 'OnlineTravelAgency'
     * Meta information extracted from the WSDL
     * - documentation: A Travel Agency operating Online
     * @return string 'OnlineTravelAgency'
     */
    const VALUE_ONLINE_TRAVEL_AGENCY = 'OnlineTravelAgency';
    /**
     * Constant for value 'TravelAgency'
     * Meta information extracted from the WSDL
     * - documentation: A Travel Agency
     * @return string 'TravelAgency'
     */
    const VALUE_TRAVEL_AGENCY = 'TravelAgency';
    /**
     * Constant for value 'TravelManagementCompany'
     * Meta information extracted from the WSDL
     * - documentation: A Travel Management Company
     * @return string 'TravelManagementCompany'
     */
    const VALUE_TRAVEL_MANAGEMENT_COMPANY = 'TravelManagementCompany';
    /**
     * Return allowed values
     * @uses self::VALUE_ONLINE_TRAVEL_AGENCY
     * @uses self::VALUE_TRAVEL_AGENCY
     * @uses self::VALUE_TRAVEL_MANAGEMENT_COMPANY
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_ONLINE_TRAVEL_AGENCY,
            self::VALUE_TRAVEL_AGENCY,
            self::VALUE_TRAVEL_MANAGEMENT_COMPANY,
        );
    }
}
