<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AcceptanceRuleType StructType
 * Meta information extracted from the WSDL
 * - documentation: A rule which is an account or representation of the certain or major aspects, characteristics, or features of a person, object, or event.
 * @subpackage Structs
 */
class AcceptanceRuleType extends AbstractStructBase
{
    /**
     * The DescText
     * Meta information extracted from the WSDL
     * - documentation: Description text value. | Text is a character string such as a finite set of characters generally in the form of words of a language.
     * - base: xs:string
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DescText;
    /**
     * Constructor method for AcceptanceRuleType
     * @uses AcceptanceRuleType::setDescText()
     * @param string $descText
     */
    public function __construct($descText = null)
    {
        $this
            ->setDescText($descText);
    }
    /**
     * Get DescText value
     * @return string|null
     */
    public function getDescText()
    {
        return $this->DescText;
    }
    /**
     * Set DescText value
     * @param string $descText
     * @return \StructType\AcceptanceRuleType
     */
    public function setDescText($descText = null)
    {
        // validation for constraint: string
        if (!is_null($descText) && !is_string($descText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($descText, true), gettype($descText)), __LINE__);
        }
        $this->DescText = $descText;
        return $this;
    }
}
