<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AirlineProfileNotifType StructType
 * Meta information extracted from the WSDL
 * - documentation: Notification payload information.
 * @subpackage Structs
 */
class AirlineProfileNotifType extends AbstractStructBase
{
    /**
     * The AirlineProfile
     * Meta information extracted from the WSDL
     * - documentation: Distribution profile of an airline which describes which types of shopping requests may be processed by a particular carrier.
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\AirlineProfileType
     */
    public $AirlineProfile;
    /**
     * Constructor method for AirlineProfileNotifType
     * @uses AirlineProfileNotifType::setAirlineProfile()
     * @param \StructType\AirlineProfileType $airlineProfile
     */
    public function __construct(\StructType\AirlineProfileType $airlineProfile = null)
    {
        $this
            ->setAirlineProfile($airlineProfile);
    }
    /**
     * Get AirlineProfile value
     * @return \StructType\AirlineProfileType
     */
    public function getAirlineProfile()
    {
        return $this->AirlineProfile;
    }
    /**
     * Set AirlineProfile value
     * @param \StructType\AirlineProfileType $airlineProfile
     * @return \StructType\AirlineProfileNotifType
     */
    public function setAirlineProfile(\StructType\AirlineProfileType $airlineProfile = null)
    {
        $this->AirlineProfile = $airlineProfile;
        return $this;
    }
}
