<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DigitalSignatureType StructType
 * Meta information extracted from the WSDL
 * - documentation: Digital Signature Structure from W3C
 * @subpackage Structs
 */
class DigitalSignatureType extends AbstractStructBase
{
    /**
     * The SignatureType
     * Meta information extracted from the WSDL
     * - documentation: Payload information for this notification message.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SignatureType
     */
    public $SignatureType;
    /**
     * Constructor method for DigitalSignatureType
     * @uses DigitalSignatureType::setSignatureType()
     * @param \StructType\SignatureType $signatureType
     */
    public function __construct(\StructType\SignatureType $signatureType = null)
    {
        $this
            ->setSignatureType($signatureType);
    }
    /**
     * Get SignatureType value
     * @return \StructType\SignatureType|null
     */
    public function getSignatureType()
    {
        return $this->SignatureType;
    }
    /**
     * Set SignatureType value
     * @param \StructType\SignatureType $signatureType
     * @return \StructType\DigitalSignatureType
     */
    public function setSignatureType(\StructType\SignatureType $signatureType = null)
    {
        $this->SignatureType = $signatureType;
        return $this;
    }
}
