<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NoChangeIndType StructType
 * Meta information extracted from the WSDL
 * - documentation: This indicates that there have been no changes to an order.
 * @subpackage Structs
 */
class NoChangeIndType extends AbstractStructBase
{
    /**
     * The NoChangeInd
     * Meta information extracted from the WSDL
     * - documentation: This indicates that there have been no changes to an order. | An indicator is a list of two mutually exclusive Boolean values that express the only possible states of a property.
     * - base: xs:boolean
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $NoChangeInd;
    /**
     * Constructor method for NoChangeIndType
     * @uses NoChangeIndType::setNoChangeInd()
     * @param bool $noChangeInd
     */
    public function __construct($noChangeInd = null)
    {
        $this
            ->setNoChangeInd($noChangeInd);
    }
    /**
     * Get NoChangeInd value
     * @return bool
     */
    public function getNoChangeInd()
    {
        return $this->NoChangeInd;
    }
    /**
     * Set NoChangeInd value
     * @param bool $noChangeInd
     * @return \StructType\NoChangeIndType
     */
    public function setNoChangeInd($noChangeInd = null)
    {
        // validation for constraint: boolean
        if (!is_null($noChangeInd) && !is_bool($noChangeInd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($noChangeInd, true), gettype($noChangeInd)), __LINE__);
        }
        $this->NoChangeInd = $noChangeInd;
        return $this;
    }
}
